<?PHP
/**
* \file reglisse.inc
* \ingroup R&eacute;glisse
* version  stable
*/

/*======================================================================== 
* ADAPTATION POSSIBLE
*/

/**
* \brief bouton de demande d'aide sauf à la racine.
*/
define ("B_INFO","<img alt='Cliquez moi pour avoir des explications' 
src = 'messagebox_info_petit.png' ");

/** 
* \enum ORDONNER_CONTRAINTES
* bouton  avec son texte activant une fonction javascript
* emploi dans 
* \li repartir_avec_contraintes_ordonnees.php
*/
define ("ORDONNER_CONTRAINTES", "<button type= 'submit' onclick ='change_action(1)'>Ordonner les contraintes</button>");

/** 
* \enum I_NB 
* d&eacute;claration de input pour le nombre de classes
* emploi dans 
* \li importer.php
*/
define ("I_NB", "<span class='item'>nombre de classes</span><input type ='text' size ='3' name = 'nb_classes'  />");

/** 
* \enum T_AFFECTATION 
* emploi dans 
* \li preciser_contraintes.php
*/
define ("T_AFFECTATION", "<span class= 'titre_5'>Choisir la fili&egrave;re &agrave; traiter</span>");

/** 
* \enum T_AJUSTER 
* emploi dans 
* \li repartir_avec_contraintes.php
*/
define ("T_AJUSTER", "Int&eacute;grer les particularit&eacute;s");


/** 
* \enum T_AUTRE_REPARTITION
* emploi dans
* \li repartir_avec_particularites.php
* \li repartition_libre.php
*/
define ("T_AUTRE_REPARTITION","Faire une autre r&eacute;partition en");

/** 
* \enum T_CHOISIR_REPARTITION
* emploi dans
* \li repartir_avec_contraintes.php
* \li repartir_avec_contraintes_ordonnees.php
*/
define ("T_CHOISIR_REPARTITION", "Méthodes par contraintes");
/** 
* \enum T_CHOIX_REPARTITION
* emploi dans
* \li repartir_avec_contraintes.php
* \li repartir_avec_contraintes_ordonnees.php
*/
define ("T_CHOIX_REPARTITION", "Choix des m&eacute;thodes de r&eacute;partition");

/** 
* \enum T_CLASSE 
* emploi dans
* \li repartir_avec_particularites.php
* \li repartition_libre.php
* \li repartir_avec_contraintes.php
 * \li repartition_avec_contraintes_inversees.php
 * \li repartir_avec_contraintes_ordonnees.php
*/
define ("T_CLASSE", "Classe: ");

/** 
* \enum T_CONSIGNE_FICHIER_DONNEES 
* emploi dans controler.php
*/
define ("T_CONSIGNE_FICHIER_DONNEES", 
"<p>
  Il faut disposer d'un fichier de cas au format csv comportant au moins
quatre colonnes renseign&eacute;es, nom, pr&eacute;nom, sexe, date de naissance. 
D&eacute;limiteur et s&eacute;parateur sont libres. </p> 
<p>Cherchez le fichier en activant le bouton parcourir puis activez 
<span class = 'tubon'>continuer</span>");


/** 
* \enum T_CONSIGNE_PARTICULARITES 
* emploi dans saisir_particularires.php
*/
define ("T_CONSIGNE_PARTICULARITES", "<p>S&eacute;lectionnez ceux pour qui
vous souhaitez pr&eacute;ciser des rapprochements &agrave; <b>tenter</b> de 
favoriser ou d'&eacute;viter <i>et</i> ceux 
qui pr&eacute;sentent une particularit&eacute; <b>imposant</b> leur dispersion ou 
leur regroupement: handicaps, horaires.</p>

<dl>
	<dt>En vid&eacute;o invers&eacute;e,</dt>
	<dd>ceux pour lesquels on a 
	d&eacute;j&agrave; saisi des particularit&eacute;s qu'on pourra 
	modifier.</dd>

	<dt>Personne ne pr&eacute;sente de particularit&eacute;s, </dt>
	<dt>Tous les individus pour lesquels on veut saisir ou modifier 
  	des particularit&eacute;s sont d&eacute;j&agrave; 
  	s&eacute;lectionn&eacute;s</dt>
  	<dd>cliquer <b>Pr&eacute;ciser les 
  	particularit&eacute;s</b>.</dd>
  
  	<dt>Supprimer toutes les particularit&eacute;s d'un individu 
  	d&eacute;j&agrave; s&eacute;lectionn&eacute;</dt>  
  	
  	<dt>Saisir les particularit&eacute;s d'un nouvel individu 
  	en conservant celles d&eacute;j&agrave; saisies pour d'autres</dt>  
  	<dd><b>CTRL Clic</b></dd>
  
      	<dt>S&eacute;lectionner plusieurs individus contigus : </dt>
      	<dd><b>Clic</b> sur le premier et <b>Maj Clic</b> sur le dernier</dd>
         <dt>S&eacute;lectionner plusieurs individus non contigus</dt>
         <dd><b>CTRL Clic</b> sur chacun</dd>
          <dt>D&eacute;s&eacute;lectionner un individu</dt> 
          <dd><b>CTRL Clic</b></dd>
</dl>
<p>Les choix &eacute;tant faits et les choses ce que nous savons, 
	activer le bouton <span class = 'tubon'>Pr&eacute;ciser les particularit&eacute;s</span>.
	</p>
</ul>");

/** 
\enum T_CONSIGNE_PARTICULARITES_2 
* emploi dans saisir_particularites_2.php
*/
define ("T_CONSIGNE_PARTICULARITES_2", "<p>Rep&eacute;rez dans la liste 
de droite les num&eacute;ros des individus et reportez-les dans la case 
appropri&eacute;e de la liste de gauche. Cochez ou recochez si 
n&eacute;cessaire Grouper, Disperser ou Standard dont 
la s&eacute;lection automatique n'est pas toujours visible (probl&egrave;me 
de navigateur), mais dont le texte d'accompagnement est en gras pour le cas 
s&eacute;lectionn&eacute;.");

/**
* string
* emploi dans identifier_separateur.php
*/
$t_consigne_delimiteur = <<<EOD
<p>Voici les solutions plausibles, dont une est s&eacute;lectionn&eacute;e 
par R&eacute;glisse.</p>
<p>Le bon choix s&eacute;pare correctement les intitul&eacute;s des colonnes, 
comme ceci <b>"Nom"||"Pr&eacute;nom"||</b> etc
 ou
<b>'Nom'||'Pr&eacute;nom'||</b></p>
<p>S&eacute;lectionnez la ligne correcte. Sinon ouvrez le fichier avec un 
tableur, sauvegardez-le au format du tableur, puis au format CSV, codage UTF-8
d&eacute;limiteur virgule, point-virgule ou deux-points , et s&eacute;parateur 
de texte <b>&quot;</b>.</p>
EOD;

define ("T_CLASSES", "classe(s)"); 


/**
* \enum T_DISPERSER
* emploi dans saisir_particularites_2.php
*/
define ("T_DISPERSER", "<span class= 'item1'>Disperser</span>");

/* 
* \enum T_EFFECTIF_CLASSE
* emploi dans 
* \li repartir_avec_particularites.php
* \li repartition_libre.php
* \li repartir_avec_contraintes.php
 * \li repartition_avec_contraintes_inversees.php

*/
DEFINE ("T_EFFECTIF_CLASSE", "Effectif: ");


/** 
* \enum T_EFFECTIF_INSUFFISANT
* emploi dans repartition_libre.php
*/
define ("T_EFFECTIF_INSUFFISANT", 
"Nombre d'&eacute;l&egrave;ves inf&eacute;rieur au nombre de groupes 
demand&eacute;");

define ("T_ELOIGNEMENTS", " &Eacute;loignements: ");
/** 
* enum T_FEMININS
* emploi dans 
* \li repartir_avec_particularites.php
* \li repartition_libre.php
* \li repartir_avec_contraintes.php

*/
define("T_FEMININS", "f&eacute;minins");

/**
* \enum T_GROUPER
* emploi dans saisir_particularites_2.php
*/
define ("T_GROUPER", "<span class= 'item1'>Grouper</span>");

/**
* \enum T_LIGNE_ANORMALE
* emploi dans importer.php
*/
define ("T_LIGNE_ANORMALE", "<span class= 'erreur'>Ligne mal construite. </span>");



/**
* \enum T_LOGIN_ABSENT
* emploi dans 
* \li controler.php
*/
define ("T_LOGIN_ABSENT", 
"<span class= 'erreur'>Vous devez fournir un identifiant. </span>");



/**
* \enum T_LOGIN_ATTRIBUE
* emploi dans 
* \li controler.php
*/
define ("T_LOGIN_ATTRIBUE", 
"<span class= 'succes'>Voici votre identifiant:  </span>");

/** 
\enum T_MANQUE_CRITERE
* emploi dans 
* \li repartir_avec_contraintes_ordonnees.php
*/
define ("T_MANQUE_CRITERE", "Il faut au moins un crit&egrave;re de tri");

/** 
* \enum T_MASCULINS
* emploi dans 
* \li repartir_avec_particularites.php
* \li repartition_libre.php
* \li repartir_avec_contraintes.php

*/
define("T_MASCULINS", "masculins");

function liste_classes ($effectif, $nb = 1)
{
	$selected = ($nb == 1) ? "selected = 'selected'": "";
	$liste_classes = "<select name = 'nb_classes'> <option $selected value ='1'>1</option>";
	for ($i = 2; $i < $effectif; $i++)
	{
		$selected = ($nb ==$i) ? "selected = 'selected'": "";
		$liste_classes .= "<option $selected value ='$i'>$i</option>";
	}
	$liste_classes .= "</select>";
	return $liste_classes;
}
/** \enum T_NB */
define ("T_NB", "<select name = 'nb_classes' 'reset' style ='font-weight:bolder;
background-color:lavender ; border:none' onClick= ''>Classe(s)</button>");

/**
\enum T_NEUTRE 
* emploi dans saisir_particularites_2.php
*/
define ("T_NEUTRE", "<span class= 'item1'>Standard</span>");

/** 
* \enum T_NOM_FICHIER_LISTE
* emploi dans 
* \li repartir_avec_particularites.php
* \li repartition_libre.php
* \li repartir_avec_contraintes.php
 * \li repartition_avec_contraintes_inversees.php
* \li repartir_avec_contraintes_ordonnees.php

*/
define ("T_NOM_FICHIER_LISTE", "<span class = 'item1'>Ce r&eacute;sultat est 
enregistr&eacute; au format csv  d&eacute;limit&eacute; par ; (point-virgule) 
dans ce fichier : </span>");


/** \enum T_NOMBRE_DE_CLASSES_ABSENT
* emploi dans 
* \li repartir_avec_particularites.php
* \li repartition_libre.php
*/
define ("T_NOMBRE_DE_CLASSES_ABSENT", "Il faut fournir un nombre de classes");

/** 
* \enum T_ORDONNER_CONTRAINTES
* emploi dans 
* \li preciser_contraintes.php
*/
define ("T_ORDONNER_CONTRAINTES", 
  " Hi&eacute;rarchiser");


/**
* \enum T_PASSE
* emploi dans controler.php
*/
define ("T_PASSE", "
<span class= 'item'>Cr&eacute;ez-vous un mot de passe.</span>");



/** 
* \enum T_PRECISER 
* emploi dans
* \li saisir_particularites.php
*/
define ("T_PRECISER", 
"Pr&eacute;ciser les particularit&eacute;s");
  
/** 
* \enum T_PRI 
* emploi dans
* \li ordonner_contraintes.php
*/
define ("T_PRI", "Dans les cases blanches<br> 
                    tapez des nombres diff&eacute;rents,<br> 
                    de 1  pour le crit&egrave;re le plus prioritaire,<br> 
                    &agrave; 10 pour le moins prioritaire,<br>
                    pour indiquer l'ordre suivant lequel <br>
                    se fait le tri. 
                    <p>Ne mettez rien pour ceux <br>qu'il faut ignorer.");
  
/** 
* \enum T_PROBLEME_TRANSFERT
* emploi dans identifier_separateur.php
*/
define ("T_PROBLEME_TRANSFERT" , "Le fichier .csv n'a pu être copi&eacute;. 
Si vous êtes d&eacute;j&agrave; pass&eacute; par cette page avec le même 
identifiant, il faut d'abord supprimer  ce fichier de donn&eacute;es :");

define ("T_RAPPROCHEMENTS", " Rapprochements: ");
/** 
* \enum T_RAPPROCHEMENTS_INDESIRABLES 
* emploi dans saisir_particularites_2.php
*/
define ("T_RAPPROCHEMENTS_INDESIRABLES",  
  "<span class ='item1'>sans</span>");

/** 
* \enum T_RAPPROCHEMENTS_SOUHAITES 
* emploi dans saisir_particularites_2.php
*/
define ("T_RAPPROCHEMENTS_SOUHAITES",  
  "<span class ='item1'>avec</span>");

/** 
* \enum T_RATIO_CLASSE 
* emploi dans 
* \li repartir_avec_particularites.php
* \li repartition_libre.php
* \li repartir_avec_contraintes.php
* \li repartition_avec_contraintes_inversees.php
* \li repartir_avec_contraintes_ordonnees.php
*/
define ("T_RATIO_CLASSE","Ratio m/total de la classe: ");

/** 
* \enum T_RATIO_TOTAL 
* emploi dans 
* \li repartir_avec_particularites.php
* \li repartition_libre.php
* \li repartir_avec_contraintes.php
* \li repartition_avec_contraintes_inversees.php
* \li repartir_avec_contraintes_ordonnees.php
*/
define ("T_RATIO_TOTAL","Ratio m/total de la population: ");
define ("T_RAPPEL", "Rappel des choix");


/** 
* \enum T_REESSAYER
* emploi dans identifier_separateur.php
*/
define ("T_REESSAYER", "R&eacute;essayer");


/** 
* \enum T_REPARTIR_AVEC 
* emploi dans enregister_particularites_2.php
*/
define ("T_REPARTIR_AVEC", 
  "R&eacute;partir suivant les affinit&eacute;s en");
/** 
* \enum T_REPARTIR_AVEC_SANS
* emploi dans enregister_particularites_2.php
*/
define ("T_REPARTIR_AVEC_SANS", 
  "R&eacute;partir sans avoir pr&eacute;cis&eacute; d'affinit&eacute;s en");
/** 
* \enum T_REPARTIR_CONTRAINTES_CROISEES
* emploi dans 
* \li preciser_contraintes.php
*/
define ("T_REPARTIR_CONTRAINTES_CROISEES", 
  "Contraintes crois&eacute;es");

 
/** 
* \enum T_REPARTIR_CONTRAINTES_INVERSEES
* emploi dans 
* \li preciser_contraintes.php
*/
define ("T_REPARTIR_CONTRAINTES_INVERSEES", 
  "Contraintes invers&eacute;es"); 
  
 
/** 
* \enum T_REPARTIR_CONTRAINTES_ORDONNEES
* emploi dans 
* \li ordonner_contraintes.php
*/
define ("T_REPARTIR_CONTRAINTES_ORDONNEES", 
  "Contraintes ordonn&eacute;es"); 
  
  
/** 
* \enum T_REPARTIR_CONTRAINTES_SIMPLES
* emploi dans 
* \li preciser_contraintes.php
*/
define ("T_REPARTIR_CONTRAINTES_SIMPLES", 
  "Contraintes simples");
  
/** 
* \enum T_REPARTIR_JACQUARD
* emploi dans 
* \li preciser_contraintes.php
*/
define ("T_REPARTIR_JACQUARD", 
  "Indice de Jacquard");
  
  /** 
* \enum T_REPARTIR_LIBRES
* emploi dans importer.php
*/
define ("T_REPARTIR_LIBRES", 
  "R&eacute;partir en");
/** 
* \enum T_REPARTIR_PARTICULARITES
* emploi dans importer.php
*/
define ("T_REPARTIR_PARTICULARITES", 
"R&eacute;partir par particularit&eacute;s en");
  
/** 
* \enum T_REPARTITIONS_CONTRAINTES
* emploi dans importer.php
*/
define ("T_REPARTITIONS_CONTRAINTES", 
  "R&eacute;partitions par contraintes");

/** 
* \enum T_REPARTITIONS_LIBRES
* emploi dans importer.php
*/
define ("T_REPARTITIONS_LIBRES", 
  "R&eacute;partitions libres");


/** 
* \enum T_REPARTITIONS_PARTICULARITES
* emploi dans importer.php
*/
define ("T_REPARTITIONS_PARTICULARITES", 
"R&eacute;partitions par particularit&eacute;s ");

/** 
* \enum T_RESAISIR_PARTICULARITES
* emploi dans importer.php
*/
define ("T_RESAISIR_PARTICULARITES", 
"Sp&eacute;cifier des particularit&eacute;s");

/** 
* \enum T_REIMPORTER 
* emploi dans
* \li preciser_contraintes.php
*/
define ("T_REIMPORTER", 
"Importer un fichier de donn&eacute;es");

/** 
* \enum T_RETOUR_MENU 
* emploi dans 
* \li repartir_avec_particularites.php
* \li enregister_particularites_2.php
* \li preciser_contraintes.php
* \li repartition_libre.php
* \li repartir_avec_contraintes.php
 * \li repartition_avec_contraintes_inversees.php
* \li repartir_avec_contraintes_ordonnees.php
*/
define ("T_RETOUR_MENU", 
  "Menu principal");

/** 
* \enum T_SANS_AFFECTATION 
* emploi dans 
* |li preciser_contraintes.php
* |li ordonner_contraintes.php
*/
define ("T_SANS_AFFECTATION", "sans");

/**
* \enum T_SEUIL_JACQUARD
* emploi dans 
* \li repartir_avec_contraintes.php
 * \li repartition_avec_contraintes_inversees.php
* \li repartir_avec_contraintes_ordonnees.php
*/
define ("T_SEUIL_JACQUARD", "<span class = 'item1'>seuil de ressemblance</span>
  <select name = 'seuil_jacquard'> 
<option value ='1'>&eacute;galit&eacute; stricte</option>
<option value ='0.8'>tr&egrave;s forte ressemblance</option>
<option value ='0.7'>forte ressemblance</option>
<option value ='0.5'>moiti&eacute; de points communs</option>
<option value ='0'>dans tous les cas</option>
</select>");

/** \enum T_TITRE_1 */
define ("T_TITRE_1", "<h1>R&eacute;glisse</h1>");

/** \enum T_TITRE_CROISEES
* emploi dans 
* \li repartir_avec_contraintes_croisees.php
*/
define ("T_TITRE_CROISEES",
 "<h1>R&eacute;glisse r&eacute;partition sur contraintes crois&eacute;es</h1>");

/** \enum T_TITRE_ORDONNEES
* emploi dans 
* \li repartir_avec_contraintes_ordonnees.php
*/
define ("T_TITRE_ORDONNEES", 
"<h1>R&eacute;glisse r&eacute;partition sur contraintes hi&eacute;rarchis&eacute;es</h1>");

/** \enum T_TITRE_ORDONNER
* emploi dans 
* \li ordonner_contraintes.php
*/
define ("T_TITRE_ORDONNER", 
"<h1>R&eacute;glisse hi&eacute;rarchisation des contraintes</h1>");

/** \enum T_TITRE_SIMPLES
* emploi dans 
* \li repartir_avec_contraintes.php
*/
define ("T_TITRE_SIMPLES", 
"<h1>R&eacute;glisse r&eacute;partition sur contraintes simples</h1>");

/** \enum T_TITRE_INV 
* emploi dans 
* \li repartir_avec_particularites.php
* \li enregister_particularites_2.php
* \li preciser_contraintes.php
* \li repartition_libre.php
* \li repartir_avec_contraintes.php
 * \li repartition_avec_contraintes_inversees.php
*/
define ("T_TITRE_INV", 
"<h1>R&eacute;glisse r&eacute;partition sur contraintes invers&eacute;es</h1>");


/** 
* string
* emploi dans identifier_separateur.php
*/
$t_consigne_separateur =
<<<EOD
<p>Les intitul&eacute;s sont entour&eacute;s de ' ou de " ou de rien; 
cochez cette valeur ci-contre :
EOD;

$t_effectif =
<<<EOD
 Effectif: 
EOD;

/** 
* string
* emploi dans identifier_separateur.php
*/
$t_expl_separateur =
<<<EOD
<p>Les tableurs ajoutent presque syst&eacute;matiquement un s&eacute;parateur, 
en g&eacute;n&eacute;ral la double quote.</p>
<p>Si vous vous trompez de s&eacute;parateur, les &eacute;l&eacute;ments 
de vos listes seront justes, mais, au lieu de se pr&eacute;senter ainsi:
<br />Einstein Albert<br />
elles seront ainsi:<br />
"Einstein" "Albert"<br />
ou<br />
'Einstein' 'Albert'</p>
EOD;

/*
===================================================================
===================================================================
		Fin des modifications possibles
===================================================================
====================================================================
*/

/*================A laisser tel quel =======================================*/
/** 
* string bas_de_page pour faire comme tout le monde 
* ne pas supprimer, ajouter &eacute;ventuellement son propre nom.
*/
$bas_de_page = "<div style='position:absolute;top:98%;left:35%;border:none;font-size:8pt; text-align:center'>
R&eacute;glisse version Sqlite 3, logiciel GPL &copy; Michel Barth&eacute;l&eacute;my Billard Sirakawa  juillet 2011.</div>"; 

$bas_de_page_1 = "<div style='position:absolute;top:95%;left:25%;border:none;font-size:8pt; text-align:center'>
R&eacute;glisse version Sqlite 3, logiciel GPL &copy; Michel Barth&eacute;l&eacute;my Billard Sirakawa  juillet 2011.

    <a href='http://validator.w3.org/check?uri=referer'><img
      src='http://www.w3.org/Icons/valid-xhtml10-blue' alt='Valid XHTML 1.0 Strict' height='31' width='88' /></a>
  </div>"; 

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


/** string quote pour les d&eacute;limiteurs*/
$quote = chr(39);
/** string quote double pour les d&eacute;limiteurs*/
$quote_double = chr(34);
/** string tabulation pour les d&eacute;limiteurs*/
$tab = chr(9);



/**
* \brief cr&eacute;e un nom pour le fichier de r&eacute;partitions.
* se substitue &agrave; la fonction php qui cr&eacute;e un fichier de nom unique impossible 
* &agrave; retenir; de plus ce nom, &agrave; ma connaissance, n'a pas d'extension...
* \param $date n'importe quelle chaine, ici une partie de la date (quantieme, mois), 
* \param $type l'extension
* \param $chemin_resultat le chemin où doit se situer le fichier de r&eacute;sultats
* \return string nom unique de fichier commençant par liste et comportant une partie de 
* la date et un num&eacute;ro d'ordre dans la date
*/
function genere_nom ($date, $type, $chemin_resultat)
{
 $chemin_resultat = "bases/";
  $i =1;
  $nom_fic = "listes_".$date."_".$i.$type;
  $nom_test = $chemin_resultat. $nom_fic;
  while (file_exists($nom_test)):
    $i++;
	  $nom_fic = "listes_".$date."_".$i.$type;
	$nom_test= $chemin_resultat."listes_".$date."_".$i.$type;
  endwhile;
return $nom_fic;

}
/** 
* \brief teste l'existence d'une base au nom du login tap&eacute;
*/
function base_existe ($login)
{
  $nom_base = $login. ".db";
  $nom_dir = dirname($_SERVER['SCRIPT_FILENAME'])."/bases/";
  $nom_base = $nom_dir.$nom_base;
  if (file_exists($nom_base)):
    return array( $login, $nom_base, true);
  else:
    $resultat = genere_nom_base ($login);
    $login = $resultat [0];
    $base = $resultat[1];
    return array ($login, $base, false);
  endif;
}

function jacquardiser_cas($cas)
	{
		$jacquard = array();
		$jacquard[] = $cas['contrainte_1'];
		$jacquard[] = $cas['contrainte_2'];
		$jacquard[] = $cas['contrainte_3'];
		$jacquard[] = $cas['contrainte_4'];		
		$jacquard[] = $cas['contrainte_5'];
		$jacquard[] = $cas['contrainte_6'];
		$jacquard[] = $cas['contrainte_7'];
		$jacquard[] = $cas['contrainte_8'];
		$jacquard[] = $cas['contrainte_9'];
		$jacquard[] = $cas['contrainte_10'];
		return $jacquard;
	
	}
	function calculer_jacquard ($cas_1, $cas_2, $ponderer)
	{
	$m11 = 0;
	$m00=0;
	$m10=0;
	$m01=0;

	for ($i = 0; $i <=9; $i ++):
  if ($ponderer):
      $ponderation = ($i >=5)? 0.8:1.2;	
  else:
    $ponderation =1;
  endif;
		$val1 = $cas_1[$i];
		$val2 = $cas_2[$i];
		if ($val1 == $val2):
			$m11 += 1*$ponderation;
		else:
			$m01++;
			$m10++;
			$m00++;
		endif;
	endfor;
	$indice = ($m11 /($m01+$m10+$m11));
return $indice;

	}

/**
* calcule le ratio g&eacute;n&eacute;ral de la population
* \param $db la variable de la classe MyDB
* \return le ratio
*/
function ratio ($db)
{
  $requete = "select count(*) from eleves";
  $resultat = $db->query($requete);
  $ligne = $resultat->fetchArray();
  $nb_total = $ligne[0];
  $requete = "select count(*) from eleves where eleve_sexe ='M'";
  $resultat = $db->query($requete);
  $ligne = $resultat->fetchArray();
  $nb_masc = $ligne[0];
  $ratio_total = round($nb_masc / $nb_total,2);
  return $ratio_total;
}


/**
* calcule le ratio de la classe
* \param $db la variable de la classe MyDB
* \param $num_classe le num&eacute;ro de la	 classe
* \return le ratio et le nombre d'&eacute;lèves de la classe
*/
function ratio_classe ($db, $num_classe)
{
  $requete = "select count(*) from eleves where affecte = $num_classe";
  $resultat = $db->query($requete);
  $ligne = $resultat->fetchArray();
  $nb_total = ($ligne[0] < 1) ? 0.0001: $ligne[0];
  $requete = "SELECT count(eleve_id) FROM eleves WHERE( eleve_sexe= 'M' 
  and affecte =$num_classe);";  
  $resultat = $db->query($requete);
  $ligne = $resultat->fetchArray();
  $nb_masc = $ligne[0];
  $ratio = round($nb_masc / $nb_total,2);
  return array($ratio, $nb_total);
}

/**
* \brief cr&eacute;e un nom de base de donn&eacute;es &agrave; partir du login souhait&eacute; par l'utilisateur
* \param $login le login de l'utilisateur
* \return un identifiant nom de base valide unique
*/
function genere_nom_base ($login)
{
	global $chemin_resultat;
	$i =1;
	/** $nom_login string le login souhait&eacute; suivi de _ et d'un chiffre incr&eacute;ment&eacute;
	*	jusqu'&agrave; être nouveau
	*/
	$nom_login = $login. "_".$i;
	/** $nom_dir string le chemin des bases de donn&eacute;es est le sous-r&eacute;pertoire 
	* bases du r&eacute;pertoire principal de R&eacute;glisse*/
	$nom_dir = dirname($_SERVER['SCRIPT_FILENAME'])."/bases/";
	/** $nom_base string $nom_login suivi de .db	*/	
	$nom_base = $nom_login.".db";
	/** $nom_test string cehmin complet de la base de donn&eacute;es*/
	$nom_test = $nom_dir.$nom_base;
	while (file_exists($nom_test)):
		$nom_login = $login."_".$i++;
		$nom_base = $nom_login.".db";
		$nom_test = $nom_dir.$nom_base;
	endwhile;
	return array($nom_login, $nom_test);
}




?>
